const { StringDecoder} = require('string_decoder');

exports.latex2dvi = function(latex_code, cb) {
    try {
        var readStream = require("latex")(latex_code, {'format': "dvi"});
        readStream.on('error', function() {
            console.log("READSTREAM ERROR");

            cb("");

            return -1;
        });
        readStream.on('done', function() {
            console.log("READSTREAM DONE");
        });
        readStream.on('end', function() {
            console.log("READSTREAM END");
        });

        cb(readStream);
    } catch(err) {
        console.log("ERROR!!!");
        console.log(err);
    }

    return 0;
}

exports.dvi2svg = function(dvi_stream, cb) {
    if(dvi_stream == "") {
        cb("");

        return -1;
    } else {
        var readStream = require("./dvisvgmwrapper")(dvi_stream);
        
        cb(readStream);
    
        return 0;
    }
}

exports.compressSVG = function(svg_code) {
    // Use SVGO - dummy for now
    return svg_code;
}

exports.latex2svg = function(latex_code, cb) {
    exports.latex2dvi(latex_code, (dvi_stream) => {
        exports.dvi2svg(dvi_stream, (svg_stream) => {
        var res = '';

        if(svg_stream == "") {
            cb("");
            return -1;
        } else {
            svg_stream.on('data', function(chunk) {
                console.log("PART");
                var part = chunk.toString();
                res += part;
            });
    
            svg_stream.on('end', function() {
                console.log("END");
                if(res == "") {
                    cb("Error");
                } else {
                    cb(res);
                }
            });
    
            svg_stream.on('close', function() {
                console.log("close");
            });
    
            svg_stream.on('error', function() {
                console.log("error");
            });
    
            svg_stream.on('readable', function() {
                console.log("readable");
            });
        }
    });
    });

    return 0;
}
